#include "emmix.h"
void estepmvn_(double *y, int *pn, int *pp, int *pg,
double * pro, double * mu, double * sigma, 
double * tau, double * sumtau,double * loglik,int * pinfo)
{
int n = * pn, g = * pg;
int i,k,info =0;
const double zero = 0.0;
denmvn(y,pn,pp,pg,mu,sigma,tau,&info);
if(info) {*pinfo=5;return;}
F77_SUB(gettau)(tau,pro,loglik,pn,pg,&info);
if(info) {*pinfo=5;return;}
for(k=0;k<g;k++) sumtau[k]=zero;
for(i=0;i<n;i++)
    for(k=0;k<g;k++) sumtau[k] += tau[k*n+i];
for(k=0;k<g;k++) 	pro[k]=sumtau[k]/(double)n;
*pinfo=info;
return;
}
void estepmvt_(double *y, int *pn, int *pp, int *pg,
double * pro, double * mu, double * sigma, double *dof,
double * tau, double * sumtau,double * xuu,double * sumxuu,
double * sumxuuln, double * loglik,int * pinfo)
{
int n = * pn, p = *pp, g = * pg;
const double two =  2.0,zero = 0.0;
int i,k,info=0;
double temp;
F77_SUB(denmvt2)(y,pn,pp,pg,mu,sigma,dof,tau,xuu,&info);
if(info) {*pinfo=5;return;}
F77_SUB(gettau)(tau,pro,loglik,pn,pg,&info);
if(info) {*pinfo=5;return;}
for(k=0;k<g;k++) {
	sumtau[k]=zero;
	sumxuu[k]=zero;
	sumxuuln[k]=zero;
}
for(i=0;i<n;i++)
	for(k=0;k<g;k++) {
		sumtau[k]   += tau[k*n+i];
		sumxuu[k]   += tau[k*n+i]*xuu[k*n+i];
		sumxuuln[k] += tau[k*n+i]*(log(xuu[k*n+i])-xuu[k*n+i]);
	}
for(k=0;k<g;k++) {
	temp = ( (double)p +dof[k] )/two;
	pro[k]=sumtau[k]/(double)n;
    sumxuuln[k] += - ( log(temp)-digamma(temp) )*sumtau[k]; }
*pinfo=info;
return;
}
