      subroutine skew(y,n,p,ng,tau,sumtau,mean,sigma,delta)
      implicit none
      integer p,n,ng
      double precision y(n,*),mean(p,*),delta(p,*)
      double precision tau(n,*),sumtau(*),sigma(p,p,*)
      integer i,j,h
      do h=1,ng
      do j=1,p
        delta(j,h)=0.0
        if( sumtau(h) .gt. 2.0) then
        do i=1,n
        delta(j,h)=delta(j,h)+(( y(i,j)-mean(j,h))*tau(i,h))**3
        enddo
        delta(j,h)=delta(j,h)/sumtau(h)/sigma(j,j,h)
     &  /sqrt(sigma(j,j,h))
        if(abs(delta(j,h)) .lt. 0.10) then
          delta(j,h)=0.0
        elseif(delta(j,h) .gt. 0.0) then
           delta(j,h)=+5.0
        else
           delta(j,h)=-5.0
        endif
        endif
      enddo
      enddo
      return
      end
      subroutine estepmst(x,n,p,g,pro,mu,sigma,dof,delta,
     &tau,ev,elogv,ez1v,ez2v,sumtau,sumvt,sumzt,sumlogv,loglik,
     &error,method)
      implicit NONE
      integer            n, p, G, error, method(g)
      double precision   loglik
      double precision   x(n,*), tau(n,  *  ),dof(*),delta(p,*)
      double precision   mu(p,*), Sigma(p,p,*), pro(  *  )
      double precision   ev(n,*), elogv(n,*), sumtau(*),sumlogv(*)
      double precision   ez1v(n,*), ez2v(n,*),sumvt(*),sumzt(*)
      integer                  i,  k
      double precision        zero, one, two
      parameter              (zero = 0.d0, one = 1.d0, two = 2.d0)
      error  = 0
      call denmst2(x,n,p,g,mu,sigma,dof,delta,
     &tau,ev,elogv,ez1v,ez2v,error,method)
      if(error .ne. 0) then
            error=22
            return
      endif
      loglik = zero
      call gettau(tau,pro,loglik,n,g,error)
      if(error .ne. 0) then
            error=23
            return
      endif
      do k=1,G
        sumtau(k)=zero
        sumzt(k)=zero
        sumvt(k)=zero
        sumlogv(k)=zero
        do i=1,n
          sumtau(k)   =sumtau(k)   +tau(i,k)
          sumzt(k)=sumzt(k)+ez2v(i,k)*tau(i,k)
          sumvt(k)=sumvt(k)+ev(i,k)  *tau(i,k)
          sumlogv(k)=sumlogv(k)+(elogv(i,k))*tau(i,k)
        enddo
      enddo
      do k=1,G
        pro(k)=sumtau(k)/dble(n)
      end do
      return
      end
      subroutine mstepmst(y,n,p,ng,ncov,
     &tau,ev,ez1v,ez2v,sumtau,sumvt,sumzt,
     &mu,sigma,delta)
      implicit none
      integer n,p,ng,ncov
      double precision y(n,*), mu(p,*), sigma(p,p,*)
      double precision delta(p,*),tau(n,*),sumtau(*)
      double precision   ev(n,*)
      double precision ez1v(n,*),  ez2v(n,*),sumvt(*),sumzt(*)
      double precision sum,tmp
      integer h,i,j,k
      double precision        zero, one, two
      parameter              (zero = 0.d0, one = 1.d0, two = 2.d0)
      do 1000 h=1,ng
        do 100 j=1,p
          do 100 i=1,p
            sigma(i,j,h)=zero
100     continue
        do 200 j=1,p
          do 200 k=j,p
            do i=1,n
      sigma(j,k,h)=sigma(j,k,h)
     &+((y(i,j)-mu(j,h)  )*( y(i,k)-mu(k,h))*ev(i,h)
     &- delta(j,h)*( y(i,k)-mu(k,h))*ez1v(i,h)
     &- delta(k,h)*( y(i,j)-mu(j,h))*ez1v(i,h)
     &+ delta(j,h)*delta(k,h)*ez2v(i,h))*tau(i,h)
            enddo
200     continue
        do 300 i=1,p
          do 300 j=i,p
          if(sumtau(h) .lt. two) then
            sigma(i,j,h)=zero
          else
            sigma(i,j,h)=sigma(i,j,h)/sumtau(h)
          endif
            sigma(j,i,h)=sigma(i,j,h)
300     continue
1000  continue
      if(ncov .ne.3) then
         call getcov(sigma,sumtau,n,p,ng,ncov)
      endif
c   calculate the means
      do 10 h=1,ng
       do 10 j=1,p
         sum=zero
         tmp=zero
         do 20 i=1,n
         sum=sum+( y(i,j)*ev(i,h)
     &            - delta(j,h)*ez1v(i,h) ) * tau(i,h)
         tmp=tmp+(y(i,j)-mu(j,h))*(ez1v(i,h)*tau(i,h))
20    continue
         if(sumtau(h)  .lt. two) then
         mu(j,h) = zero
         delta(j,h) =zero
         else
         mu(j,h)=sum/sumvt(h)
         delta(j,h)=tmp/sumzt(h)
         endif
10    continue
      return
      end
