#include "emmix.h"
double F77_SUB(mygammln)(double * x)
{
return(lgammafn(x[0]));
}
double F77_SUB(mvphit)(double *x, double *v)
{
return(pt(x[0],v[0],1,0));
}
double F77_SUB(mvphin)(double *x)
{
double mu=0,sd=1;
return(pnorm5(x[0],mu,sd,1,0));
}
double F77_SUB(mydnorm)(double *x)
{
double mu=0,sd=1;
return(dnorm4(x[0],mu,sd,0));
}
double F77_SUB(mydigamma)(double *x)
{
return(digamma(x[0]));
}
void absrng_(double * v, int* p, double * vmin, double * vmax)
{
int m = *p,i;  
double tmp;
tmp= fabs(v[0]);
vmin[0] = tmp;
vmax[0] = tmp;
if(m==1) return;
for(i=1;i< m;i++)
{
    tmp = fabs(v[i*m+i]);
	vmin[0] = fmin2(tmp,vmin[0]);
	vmax[0] = fmax2(tmp,vmax[0]);
}
return;
}
void nonzeromax_(double *v, int *p, double *vmax)
{
int m = *p,i;  
double tmp;
double zero=0.0;
vmax[0] = zero;
for(i=0;i<m;i++) {
if(fabs((tmp = v[i]))> zero) {vmax[0] = tmp;break;}
} 
if(m==1) return;
for(i=0;i< m;i++)
{
    if(fabs((tmp = v[i]))> zero){
	vmax[0] = (tmp > vmax[0])? tmp: vmax[0];}
}
return;
}
void F77_SUB(tau2clust)(double * tau, int *pn, int* pg, int * clust)
{
int g = *pg, n= *pn,i,j;  
double tmp,vmax;
for(i=0;i<n;i++) { 
tmp= (tau[i]);
vmax = tmp;
clust[i]=1;
if(g>1) {
for(j=1;j< g;j++)
{
    tmp = (tau[j*n+i]);
    if(tmp >= vmax) {
		vmax = tmp;
		clust[i]=j+1;
	}
} 
} 
} 
return;
}
void Zeroin_(    double *ax,    double *bx,	double (*f)(double x, void *info),	
    void *info,		double *Tol,    int *Maxit,		double *root)          
{
	
*root= R_zeroin(*ax, *bx, f, info,Tol, Maxit);
	
return;
	
}
double Tequ(double dof,void *pinfo)
{
MINFO *myinfo;
myinfo=pinfo;
double x = dof/(double)2;
return ( ( log(x)-digamma(x)+(double)1 )*(*myinfo).stau + (*myinfo).sxuu);
}
void F77_SUB(getdof)(int *pn, int *pg, double *sumtau, double *sumxuuln, double *dof, double *b)
{
int h, n=*pn, g = *pg;
int Maxit;
MINFO pinfo;
double ax=2.0001,bx= *b,root=0.0,Tol;
for(h=0;h<g;h++) {
if(sumtau[h] >= 2.0) {
Maxit=30;
Tol=1e-3;
pinfo.stau = sumtau[h]/(double)n;
pinfo.sxuu = sumxuuln[h]/(double)n;
Zeroin_(&ax,&bx,Tequ,&pinfo,&Tol,&Maxit,&root);	
dof[h]= root;
if( (Maxit <0 && Tol > 1e-4) || root <= ax)
dof[h]=bx;
} 
else
dof[h]=bx;
} 
return;
}
void myrevsort_(double  *a, int *ib, int *pn)
{
int ii, j, ir, i,n=*pn;
double ra;
if(n == 1) return;
for(i=1;i<n;i++){
    
	ir = n-i;
	ra =  a[ir];
	ii = ib[ir];
	for(j=0;j< ir;j++){
	if(ra > a[j]) {
		ra =  a[j];
		ii = ib[j];
	
		 a[j] =  a[ir];
		ib[j] = ib[ir];
		 a[ir] = ra;
		ib[ir] = ii;
	} 
	}
} 
return; 
}
void oldmyrevsort_(double *a, int *ib, int *pn)
{
revsort(a, ib, *pn);
return;
}
void SingularityHandler(double *sigma, double * sigm,double *inv, int *pp, int *pcount, int * save,double eps)
{
int p = *pp, info=0;
char uplo[]="U";
int i,j,k,ii,idx[p];
double wy[p]; 
double zero=0.0;
*pcount =0;
for(i=0;i<p;i++){
wy[i]=sigm[i*p+i];
idx[i]=i;
save[i]=0;
} 
myrevsort_(wy,idx,&p);
for(i=0;i<p;i++) // row
	for(j=0;j<p;j++) // column
		sigm[j*p+i]=sigma[j*p+i];
for(i=0;i<p;i++) {
j=idx[p-i-1];
for(k=0;k<p;k++){
sigm[j*p+k]=zero;
sigm[k*p+j]=zero;}//endfor k
sigm[j*p+j]=eps;
save[i]=j;
(*pcount)++;
for(k=0;k<p;k++) // row
	for(ii=0;ii<p;ii++) // column
		inv[ii*p+k]=sigm[ii*p+k];
info=0;
F77_NAME(dpotrf)(uplo,&p, inv, &p, &info);
if(!info && i < (p-1)){
j=idx[p-i-2];
if(sigm[j*p+j] >= eps) break;
} 
} 
return;
}
void F77_SUB(inverse3)(double *sigma, double * inv, double *pdet, 
int *pp, int * pinfo,int *pcount, int *save)
{
int p = *pp, info=0, count = 0;
int incx = 1,incy = 1;
char uplo[]="U",trans[]="T",diag[]="N";
int i,j,k,ii;
double vmin,vmax,det=0.0; 
double sigm[p*p],wy[p]; 
double eps=1e-4,one =1.0,zero=0.0;
*pinfo = 0;
*pcount=0;
if(p==1) {
     
	 if(sigma[0] < (eps/(double)100) ) {
	        
			inv[0]=(double)10/sqrt(eps);
            *pdet = eps/(double)100;
			save[0]=0;
			*pcount=1;}
	 else {
	        inv[0]=one/sqrt(sigma[0]);
            *pdet = sigma[0]; 
			save[0]=0;
	    }
     return;
}
for(i=0;i<p;i++) {// row
	for(j=i;j<p;j++) {// column
		sigm[j*p+i]=sigma[j*p+i];}}
absrng_(sigm,&p,&vmin,&vmax);
F77_NAME(dpotrf)(uplo,&p, sigm, &p, &info);

if( info != 0 || vmin < eps ) {
SingularityHandler(sigma,sigm,inv, &p, pcount,save,eps);
F77_NAME(dpotrf)(uplo,&p, sigm, &p, &info);
}
det = one;
for(j=0;j<p;j++)  
    det *= sigm[j*p+j];
det *= det;
for(k=0;k<p;k++) {// row
	for(ii=0;ii<p;ii++) // column
   	    inv[ii*p+k]=zero;
    inv[k*p+k]= one;
}
for(j=0;j< p;j++) 
{
F77_NAME(dcopy)( &p, inv+j*p, &incx, wy, &incy);
F77_NAME(dtrsv)(uplo,trans,diag,&p, sigm, &p, wy, &incy);
F77_NAME(dcopy)( &p, wy, &incx, inv+j*p, &incy);
}
*pinfo  = info;
*pdet   = det;
*pcount = count;
return;
}
void inverse4_(double *sigma, double * inv,int *pp, int *pcount, int * save)
{
int p = *pp, info=0;
int incx = 1,incy = 1;
char uplo[]="U",trans[]="T",diag[]="N";
int i,j,k,ii;
double vmin,vmax; 
double sigm[p*p],wy[p]; 
double eps=1e-4,one =1.0,zero=0.0;
*pcount=0;
if(p==1) {
     
	 if(sigma[0] < (eps/(double)100) ) {
	        inv[0]=(double)10/sqrt(eps);
			save[0]=0;*pcount=1;}
	 else {
	        inv[0]=one/sqrt(sigma[0]);
			save[0]=0;
	    }
	 return;
}
for(i=0;i<p;i++) {// row
	for(j=0;j<p;j++) {// column
		sigm[j*p+i]=sigma[j*p+i];}}
absrng_(sigm,&p,&vmin,&vmax);
F77_NAME(dpotrf)(uplo,&p, sigm, &p, &info);
if( info != 0 || vmin < eps ) {
SingularityHandler(sigma,sigm,inv, &p, pcount, save,eps);
for(i=0;i< *pcount; i++) {
	j=save[i];
	sigm[j*p+j]=one;
}
F77_NAME(dpotrf)(uplo,&p, sigm, &p, &info);
}
for(k=0;k<p;k++) {// row
	for(ii=0;ii<p;ii++) // column
   	    inv[ii*p+k]=zero;
    
	inv[k*p+k]= one;
}
for(j=0;j< p;j++) 
{
F77_NAME(dcopy)( &p, inv+j*p, &incx, wy, &incy);
F77_NAME(dtrsv)(uplo,trans,diag,&p, sigm, &p, wy, &incy);
F77_NAME(dcopy)( &p, wy, &incx, inv+j*p, &incy);
}
return;
}
void F77_SUB(getcov)(double *sigma, double *sumtau, int *pn,int *pp, int *pg, int *pncov)
{
int n= *pn,p=*pp,g=*pg,ncov=*pncov;
int i,j,k;
double sigm[p*p],tmp,zero=0;
if(ncov == 1 || ncov ==2) {
for(i=0;i<p;i++) {
	for(j=i;j<p;j++) {
       sigm[j*p+i]=zero;
       for(k=0;k<g;k++) 
	   sigm[j*p+i] += sumtau[k]*sigma[k*p*p+j*p+i];
       sigma[j*p+i]=sigm[j*p+i]/(double)n;
       sigma[j*p+i]=sigma[i*p+j];
}}
if(ncov == 2) {
for(i=0;i<p;i++) 
	for(j=0;j<p;j++) 
       if(i != j) sigma[j*p+i]=zero;  
}
if(g>1) {
for(k=1;k<g;k++)
  for(i=0;i<p;i++) 
	for(j=i;j<p;j++) {
       sigma[k*p*p+j*p+i]=sigma[j*p+i];
       sigma[k*p*p+i*p+j]=sigma[i*p+j];
}}
} 
if(ncov == 4 || ncov ==5) {
for(k=0;k<g;k++)
   for(i=0;i<p;i++) 
	for(j=0;j<p;j++) 
       if(i != j) sigma[k*p*p+j*p+i]=zero;  
if(ncov == 5) {
   for(k=0;k<g;k++) {
	    
		tmp=zero;
        
		for(i=0;i<p;i++) 
	       tmp += sigma[k*p*p+i*p+i];
		
        for(i=0;i<p;i++) 
	       sigma[k*p*p+i*p+i]=tmp/(double)p; }}
} 
return;
}
void F77_SUB(gettau)(double *tau,double *pro, double *loglik, 
int *pn, int*pg, int *pinfo)
{
int n = * pn, g = * pg;
double one =  1.0, zero = 0.0;
double prok,sum,temp;
double tmax,wx[g];
int i,k,incy=1;
*pinfo=0;*loglik=zero;tmax=zero;
for(i=0;i<n;i++){
for(k=0;k<g;k++) {
		prok=pro[k];
		if(prok == zero) 
			tau[k*n+i]=zero;
		else 
			tau[k*n+i] = log(prok) + tau[k*n+i];
} 
F77_NAME(dcopy)( &g, tau+i, &n, wx, &incy);
nonzeromax_(wx,&g,&tmax);
if(tmax == zero ){
*pinfo = 6;	   return;}
sum = zero;
for(k=0;k<g;k++) {
		if(pro[k] != zero) {
			temp=tau[k*n+i]-tmax;
			tau[k*n+i]=exp(temp);
			sum += tau[k*n+i];
		} 
} 
*loglik += log(sum)+tmax;
if(sum < one){
*pinfo = 6;	   return;}
sum = one/sum;
F77_NAME(dscal)( &g, &sum, tau+i, &n);
} 
return;
}
//end
