      subroutine predmixdamst(x,n,p,G,pro,mu,Sigma,dof,delta,
     &tau,error)
      implicit NONE
      integer            n, p, G, error
      double precision   x(n,*), tau(n,  *  ),dof(*),delta(p,*)
      double precision   mu(p,*), Sigma(p,p,*), pro(  *  )
      double precision        zero,loglik
      parameter              (zero = 0.d0)
      error  = 0
      call denmst(x,n,p,g,mu,sigma,dof,delta,tau,error)
      if(error .ne. 0) then
            error=22
            return
      endif
      loglik = zero
      call gettau(tau,pro,loglik,n,g,error)
      if(error .ne. 0) then
            error=23
            return
      endif
      return
      end
      subroutine getmodmst(p,g,k,y,mu,inv,dof,wd,tempdd,denmax,modpts)
      implicit NONE
      integer            p,k,g
      double precision wx(p),wy(p),wd(p),inv(p,p),denmax
      double precision tempyy, tempdd, tempyd, tmp, temp 
      double precision modpts(p,g),mu(p,g),dof(g),y(p)
      double precision        zero, one, two
      parameter   (zero = 0.d0, one = 1.d0, two = 2.d0)
      external                ddot, mvphit
      double precision        ddot, mvphit
          call dcopy( p, y, 1, wx, 1)
          call daxpy( p, (-one), mu(1,k), 1, wx, 1)
          call dgemv("N", p, p, one, inv, p, wx, 1, zero, wy, 1)
          tempyy = ddot( p, wy, 1, wy, 1)
          tempyd = ddot( p, wd, 1, wy, 1) 
          tmp = tempyd/sqrt((one-tempdd)
     &    *(tempyy+dof(k))/(dble(p)+dof(k)))
          temp = -log(one+tempyy/dof(k))*(dof(k)+dble(p))/two
     &    +log(two*mvphit( tmp,(dble(p)+dof(k))))
          if(temp .gt. denmax) then
            call dcopy( p, y, 1, modpts(1,k), 1)
            denmax = temp
          endif
      return
      end
      subroutine getmodmst2(p,g,k,y,mu,inv,dof,wd,tempdd,denmax,modpts)
      implicit NONE
      integer            p,k,g
      double precision wx(p),wy(p),wd(p),inv(p,p),denmax
      double precision tempyy, tempdd, tempyd, tmp, temp 
      double precision modpts(p,g),mu(p,g),dof(g),y(p)
      double precision        zero, one, two
      parameter   (zero = 0.d0, one = 1.d0, two = 2.d0)
      external                ddot, mvphit
      double precision        ddot, mvphit
          call dcopy( p, y, 1, wx, 1)
          call daxpy( p, (-one), mu(1,k), 1, wx, 1)
          call dgemv("N", p, p, one, inv, p, wx, 1, zero, wy, 1)
          
          tempyy = ddot( p, wy, 1, wy, 1)
          tempyd = ddot( p, wd, 1, wy, 1) 
          tmp = tempyd/sqrt((one-tempdd)
     &    *(tempyy+dof(k))/(dble(p)+dof(k)))
          temp = -log(one+tempyy/dof(k))*(dof(k)+dble(p))/two
     &    +log(two*mvphit( tmp,(dble(p)+dof(k))))
            call dcopy( p, y, 1, modpts(1,k), 1)
            denmax = temp
      return
      end
      subroutine mixmodmst(p,g,step,mu,sigma,dof,delta,
     +emean,esigma,modpts,error)
      implicit NONE
      integer            p, g, error
      double precision   dof(g),delta(p,g),step
      double precision   mu(p,g), sigma(p,p,g)
      double precision   emean(p,g), esigma(p,p,g),modpts(p,g)
      double precision   sigmad(p,p), wd(p), y(p)
      double precision   inv(p,p),logdet,wx(p)
      integer                 i, j, k, n
      double precision        tempdd 
      double precision        const, tsd, denmax
      integer                 i1, i2, i3, i4, i5
      integer                 i6, i7, i8, i9, i10
      double precision        zero, one, two
      parameter              (zero = 0.d0, one = 1.d0, two = 2.d0)
      double precision        pi
      parameter              (pi =    3.141592653589793239d0)
      external                ddot, mygammln
      double precision        ddot, mygammln
      integer counter,save(p),ii
      error  = 0
      if( (p .gt. 10)  ) return
      do k = 1, G
         if(dof(k) .eq. 2) return
         const = sqrt(dof(k)/pi)*exp(mygammln((dof(k)-one)/two)
     +             -mygammln(dof(k)/two))
         do i=1,p
         emean(i,k)=mu(i,k)+const*delta(i,k)
         do j=i,p
         sigmad(i,j  )=sigma(i,j,k)+delta(i,k)*delta(j,k)
         esigma(i,j,k)=sigmad(i,j)*dof(k)/(dof(k)-2)
     +             -const*const*delta(i,k)*delta(j,k)
         esigma(j,i,k)=esigma(i,j,k)
         enddo
         enddo
         tsd = zero
         do j =1, p
           if(esigma(j,j,k) .gt. tsd) then
            tsd=esigma(j,j,k)
           endif
         enddo
         tsd = sqrt(tsd)
         n = max(20,int(two*tsd/step))
         do i=1,p
         do j=i,p
         sigmad(i,j)=sigma(i,j,k)
         end do
         end do
        call inverse3(sigmad,inv,logdet,p,error,counter,save)
        if(error .ne. 0) then
                error = 11
                return
        endif
        if(counter .ge. 1) then
           do j=1,counter
              i=save(j)
              delta(i,k)=zero
              do ii=1,p
                sigmad(ii,i)=zero
                sigmad(i,ii)=zero
              enddo
              sigmad(i,i)=1e-4
           enddo
        endif
         do i=1,p
         do j=i,p
         sigmad(i,j)=sigmad(i,j)+delta(i,k)*delta(j,k)
         end do
         end do
        call inverse3(sigmad,inv,logdet,p,error,counter,save)
        if(error .ne. 0) then
                error = 22
                return
        endif
        call dcopy( p, delta(1,k), 1, wx, 1)
        call dgemv("N", p, p, one, inv, p, wx, 1, zero, wd, 1);
        tempdd = ddot( p, wd, 1, wd, 1)
        do i=1,p
          call dcopy( p, mu(1,k), 1, y, 1)
        enddo
        call getmodmst2(p,g,k,y,mu,inv,dof,wd,tempdd,denmax,modpts)
        do i1 = 1,n
           y(1)=emean(1,k)-tsd+(i1-1)*step
          if(p .eq.1) then
          call getmodmst(p,g,k,y,mu,inv,dof,wd,tempdd,denmax,modpts)
          endif
          if(p .eq.2) then
          do i2=1,n
           y(2)=emean(2,k)-tsd+(i2-1)*step
          call getmodmst(p,g,k,y,mu,inv,dof,wd,tempdd,denmax,modpts)
          enddo
          endif
          if(p.eq.3) then
          do i2=1,n
           y(2)=emean(2,k)-tsd+(i2-1)*step
          do i3=1,n
           y(3)=emean(3,k)-tsd+(i3-1)*step
          call getmodmst(p,g,k,y,mu,inv,dof,wd,tempdd,denmax,modpts)
          enddo
          enddo
          endif
          if(p.eq.4) then
          do i2=1,n
           y(2)=emean(2,k)-tsd+(i2-1)*step
          do i3=1,n
           y(3)=emean(3,k)-tsd+(i3-1)*step
          do i4=1,n
           y(4)=emean(4,k)-tsd+(i4-1)*step
          call getmodmst(p,g,k,y,mu,inv,dof,wd,tempdd,denmax,modpts)
          enddo
          enddo
          enddo
          endif
          if(p.eq.5) then
          do i2=1,n
           y(2)=emean(2,k)-tsd+(i2-1)*step
          do i3=1,n
           y(3)=emean(3,k)-tsd+(i3-1)*step
          do i4=1,n
           y(4)=emean(4,k)-tsd+(i4-1)*step
          do i5=1,n
           y(5)=emean(5,k)-tsd+(i5-1)*step
          call getmodmst(p,g,k,y,mu,inv,dof,wd,tempdd,denmax,modpts)
          enddo
          enddo
          enddo
          enddo
          endif
          if(p.eq.6) then
          do i2=1,n
           y(2)=emean(2,k)-tsd+(i2-1)*step
          do i3=1,n
           y(3)=emean(3,k)-tsd+(i3-1)*step
          do i4=1,n
           y(4)=emean(4,k)-tsd+(i4-1)*step
          do i5=1,n
           y(5)=emean(5,k)-tsd+(i5-1)*step
          do i6=1,n
           y(6)=emean(6,k)-tsd+(i6-1)*step
          call getmodmst(p,g,k,y,mu,inv,dof,wd,tempdd,denmax,modpts)
          enddo
          enddo
          enddo
          enddo
          enddo
          endif
          if(p.eq.7) then
          do i2=1,n
           y(2)=emean(2,k)-tsd+(i2-1)*step
          do i3=1,n
           y(3)=emean(3,k)-tsd+(i3-1)*step
          do i4=1,n
           y(4)=emean(4,k)-tsd+(i4-1)*step
          do i5=1,n
           y(5)=emean(5,k)-tsd+(i5-1)*step
          do i6=1,n
           y(6)=emean(6,k)-tsd+(i6-1)*step
          do i7=1,n
           y(7)=emean(7,k)-tsd+(i7-1)*step
          call getmodmst(p,g,k,y,mu,inv,dof,wd,tempdd,denmax,modpts)
          enddo
          enddo
          enddo
          enddo
          enddo
          enddo
          endif
          if(p.eq.8) then
          do i2=1,n
           y(2)=emean(2,k)-tsd+(i2-1)*step
          do i3=1,n
           y(3)=emean(3,k)-tsd+(i3-1)*step
          do i4=1,n
           y(4)=emean(4,k)-tsd+(i4-1)*step
          do i5=1,n
           y(5)=emean(5,k)-tsd+(i5-1)*step
          do i6=1,n
           y(6)=emean(6,k)-tsd+(i6-1)*step
          do i7=1,n
           y(7)=emean(7,k)-tsd+(i7-1)*step
          do i8=1,n
           y(8)=emean(8,k)-tsd+(i8-1)*step
          call getmodmst(p,g,k,y,mu,inv,dof,wd,tempdd,denmax,modpts)
          enddo
          enddo
          enddo
          enddo
          enddo
          enddo
          enddo
          endif
          if(p.eq.9) then
          do i2=1,n
           y(2)=emean(2,k)-tsd+(i2-1)*step
          do i3=1,n
           y(3)=emean(3,k)-tsd+(i3-1)*step
          do i4=1,n
           y(4)=emean(4,k)-tsd+(i4-1)*step
          do i5=1,n
           y(5)=emean(5,k)-tsd+(i5-1)*step
          do i6=1,n
           y(6)=emean(6,k)-tsd+(i6-1)*step
          do i7=1,n
           y(7)=emean(7,k)-tsd+(i7-1)*step
          do i8=1,n
           y(8)=emean(8,k)-tsd+(i8-1)*step
          do i9=1,n
           y(9)=emean(9,k)-tsd+(i9-1)*step
          call getmodmst(p,g,k,y,mu,inv,dof,wd,tempdd,denmax,modpts)
          enddo
          enddo
          enddo
          enddo
          enddo
          enddo
          enddo
          enddo
          endif
          if(p.eq.10) then
          do i2=1,n
           y(2)=emean(2,k)-tsd+(i2-1)*step
          do i3=1,n
           y(3)=emean(3,k)-tsd+(i3-1)*step
          do i4=1,n
           y(4)=emean(4,k)-tsd+(i4-1)*step
          do i5=1,n
           y(5)=emean(5,k)-tsd+(i5-1)*step
          do i6=1,n
           y(6)=emean(6,k)-tsd+(i6-1)*step
          do i7=1,n
           y(7)=emean(7,k)-tsd+(i7-1)*step
          do i8=1,n
           y(8)=emean(8,k)-tsd+(i8-1)*step
          do i9=1,n
           y(9)=emean(9,k)-tsd+(i9-1)*step
          do i10=1,n
           y(10)=emean(10,k)-tsd+(i10-1)*step
          call getmodmst(p,g,k,y,mu,inv,dof,wd,tempdd,denmax,modpts)
          enddo
          enddo
          enddo
          enddo
          enddo
          enddo
          enddo
          enddo
          enddo
          endif
      enddo  
      enddo    
      return
      end
