
#-------------------------------------

args=(commandArgs(TRUE))

print(args)

if(length(args)==0) {
stop("No arguments supplied.")
} else {

if(length(args)==2)
stop("The algorithm requires the number
of populations to be pre-identied")

InputFolder  = args[[1]];
OutputFolder = args[[2]];
g  = as.numeric(args[[3]]);
}


# install packges into Rlibs/

system('rm -rf xRlibs;rm -rf xtemp')

system("mkdir xRlibs;mkdir xtemp")

system("R CMD INSTALL -l xRlibs EMMIX_1.0.16.tar.gz")


.libPaths('xRlibs')

require(EMMIX)


#----------------------------------------- 

system(paste('rm -rf  ', OutputFolder, sep=''))

system(paste('mkdir ', OutputFolder, sep=''))

ListOfFiles=dir(paste(InputFolder, '/CSV', sep=''))



for (i in ListOfFiles) {


t0<- proc.time()

S=read.csv(paste(InputFolder, '/CSV/', i, sep=''))

ret  <- try(emmix(S,g,distr='mst',ncov=3,debug=FALSE))

if(length(ret) > 5) {

ret$time <- proc.time()-t0

dput(ret,paste('xtemp/', strsplit(i,c('.csv'))[[1]][1], '.ret',sep=''));

write.table(ret$clust,paste(OutputFolder, '/', i, sep=''), col.names=FALSE, row.names=FALSE);
} #end if

} #end of loop



#

files <- dir('xtemp',full.names=T)

timetable <- array(0,c(length(files),5))

dimnames(timetable)[[2]] <- c('user.self',   'sys.self',    'elapsed', 'user.child',  'sys.child')
dimnames(timetable)[[1]] <- files


for(i in 1:length(files))
{

ret <- dget(files[i])

timetable[i,] <- c(ret$time)

}

write.csv(timetable,'xOutput/challenge2-runtime.csv',row.names=FALSE)






# end of program



#--------------------------------

#Rscript challenge2.R $1 $2 $3

#--------------------------------

#Finally, fowcap organizers can run the code in a unix shell:


#./flowcap-challenge2.sh GvHD GvHD/Output 3